Attribute VB_Name = "modINIHandling"
Option Explicit
'API Declares
Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Integer

'This function gets the setting
Function GetINISetting(ByRef strSectionHeader As String, ByRef strVariableName As String, strSettingsPath As String, Optional ByRef strDefault As String = "") As String
    Dim strReturn As String
    Dim intLen As Integer
    strReturn = String(255, Chr(32))
    intLen = GetPrivateProfileString(strSectionHeader, strVariableName, strDefault, strReturn, Len(strReturn), strSettingsPath)
    GetINISetting = Left(strReturn, intLen)
End Function

'this function saves a setting
Function SaveINISetting(strSectionHeader As String, strVariableName As String, strValue As String, strSettingsPath As String) As Long
    SaveINISetting = WritePrivateProfileString(strSectionHeader, strVariableName, strValue, strSettingsPath)
End Function

'this one deletes a setting
Function DelINISetting(ByRef strSection As String, ByRef strSetting As String, strSettingsPath As String) As Integer
    DelINISetting = WritePrivateProfileString(strSection, strSetting, 0&, strSettingsPath)
End Function

'and this one delets an entire section
Function DelINISection(ByRef strSection As String, strSettingsPath As String) As Integer
    DelINISection = WritePrivateProfileString(strSection, 0&, 0&, strSettingsPath)
End Function

'this sets a setting to blank
Function ClearINISetting(ByRef strSection As String, ByRef strSetting As String, strSettingsPath As String) As Integer
    ClearINISetting = WritePrivateProfileString(strSection, strSetting, "", strSettingsPath)
End Function

'checks if a file exists
Public Function FileExist(dPath As String) As Boolean
    On Error GoTo errorH
    Dim strDir As String
    
    If Not Dir(dPath) = vbNullString Then
        If FileLen(dPath) > -1 Then
            FileExist = True
        End If
    Else
        FileExist = False
    End If

    Exit Function

errorH:
    FileExist = False

End Function

'check if a directory exists
Public Function DirExist(dPath As String) As Boolean
    On Error GoTo errorH
    Dim strDir As String
    
    If Dir(dPath) = vbNullString Then   'dir returns nullstring - could be a dir (cannot be a file)
        If FileLen(dPath) > -1 Then 'something is found - already decided not a file, therefore is dir
            DirExist = True
        Else
            DirExist = False
        End If
    Else
        DirExist = False
    End If

    Exit Function

errorH:
    DirExist = False

End Function

'create all folders for a given file, if the folders are not there already
Public Sub MakeDirs(strPath As String)
    Dim strWorkingPath As String
    strWorkingPath = strPath
    strWorkingPath = Left(strWorkingPath, InStrRev(strWorkingPath, "\") - 1)
    If Not Dir(strWorkingPath, vbDirectory) = "" Then
        Exit Sub
    Else
        MakeDirs (strWorkingPath)
        MkDir (strWorkingPath)
    End If
End Sub
