Attribute VB_Name = "modMain"
Option Explicit

Sub Main()
    Dim strSettingsFile As String
    Dim strAppPath As String
    Dim strSettingsPath As String
    Dim strRegistryPaths(0 To 9) As String
    Dim intNumOfRegistryPaths As Integer
    Dim strRunFile As String
    Dim intX As Integer
    Dim strWorking As String
    
    strAppPath = App.Path   'for effeciency... get the application path
    strSettingsPath = strAppPath & "\Settings\" 'compile the settings path - used to store settings.ini and all registry files
    strSettingsFile = strSettingsPath & "Settings.ini"  'set the settings.ini file
    
    intNumOfRegistryPaths = CInt(GetINISetting("Registry", "Number", strSettingsFile)) - 1  'get the number of registry entries
    
    For intX = 0 To intNumOfRegistryPaths
        strRegistryPaths(intX) = GetINISetting("Registry", "Path" & intX, strSettingsFile)
        Select Case Left(strRegistryPaths(intX), 4)
            Case "HKLM"
                strRegistryPaths(intX) = "HKEY_LOCAL_MACHINE" & Right(strRegistryPaths(intX), Len(strRegistryPaths(intX)) - 4)
            Case "HKCU"
                strRegistryPaths(intX) = "HKEY_CURRENT_USER" & Right(strRegistryPaths(intX), Len(strRegistryPaths(intX)) - 4)
            Case "HKCR"
                strRegistryPaths(intX) = "HKEY_CLASSES_ROOT" & Right(strRegistryPaths(intX), Len(strRegistryPaths(intX)) - 4)
            Case "HKU"
                strRegistryPaths(intX) = "HKEY_USERS" & Right(strRegistryPaths(intX), Len(strRegistryPaths(intX)) - 3)
        End Select
    Next intX
    
    For intX = 0 To intNumOfRegistryPaths
        strWorking = strSettingsPath & "Current" & intX & ".reg"   'for effeciency's sake... get the name of the file to export to
        ShellAndWait "regedit /E """ & strWorking & """ """ & strRegistryPaths(intX) & """" 'export the key
        strWorking = strSettingsPath & "Settings" & intX & ".reg"
        If FileExist(strWorking) Then   'if our portable settings exist, process them - if not, it will use the local settings and save them as portable
            DeleteKey strRegistryPaths(intX), strSettingsPath   'delete the key
            strWorking = strSettingsPath & "Settings" & intX & ".reg"
            ShellAndWait "regedit /I /S """ & strWorking & """"    'import our portable settings
        End If
    Next intX
    
    strRunFile = ".\" & GetINISetting("Application", "exeDir", strSettingsFile) & "\" & GetINISetting("Application", "exeFile", strSettingsFile)   'strAppPath & "\" & GetINISetting("Application", "exeDir", strSettingsFile) & "\" & GetINISetting("Application", "exeFile", strSettingsFile)  'set the name of the program to load
    
    ShellAndWait strRunFile 'run the application
    
    For intX = 0 To intNumOfRegistryPaths
        strWorking = strSettingsPath & "Settings" & intX & ".reg"   'set the name of the file to work on
        If FileExist(strWorking) = True Then    'if our old portable settings currently exist...
            Kill strWorking 'delete the old portable settings
        End If
        ShellAndWait "regedit /E """ & strWorking & """ """ & strRegistryPaths(intX) & """" 'export new potrtable key
        strWorking = strSettingsPath & "Current" & intX & ".reg"   'for effeciency's sake... get the name of the file to export to
        DeleteKey strRegistryPaths(intX), strSettingsPath   'delete the old, portable settings
        If FileExist(strWorking) Then   'if we exported old settings before...
            ShellAndWait "regedit /I /S """ & strWorking & """" 'import the old, local settings
            Kill strWorking 'kill the old settings
        End If
    Next intX
    
End Sub

Private Sub DeleteKey(strKey As String, strPath As String)
    Dim strFile As String
    strFile = strPath & "del.reg"
    Open strFile For Binary Access Write As #1
        Put #1, , "REGEDIT4"
        Put #1, , vbCrLf
        Put #1, , vbCrLf
        Put #1, , "[-" & strKey & "]"
    Close #1
    ShellAndWait "regedit /I /S """ & strFile & """"
    Kill strFile
End Sub
